"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slonik = require("slonik");

var _slonikSqlTagRaw = require("slonik-sql-tag-raw");

var _default = async (connection, joiningTableName, targetResourceTableName, joiningKeyName, lookupKeyName, identifiers, ids) => {
  let rows = []; // @todo Do not use slonik-sql-tag-raw.

  if (ids.length > 0) {
    rows = await connection.any((0, _slonik.sql)`
      SELECT
        ${_slonik.sql.identifier(['r1', lookupKeyName + '_id'])} "POSTLOADER_LOOKUP_KEY",
        ${(0, _slonikSqlTagRaw.raw)(identifiers)}
      FROM ${_slonik.sql.identifier([joiningTableName])} r1
      INNER JOIN ${_slonik.sql.identifier([targetResourceTableName])} r2 ON r2.id = ${_slonik.sql.identifier(['r1', joiningKeyName + '_id'])}
      WHERE ${_slonik.sql.identifier(['r1', lookupKeyName + '_id'])} = ANY(${_slonik.sql.array(ids, 'int4')})
    `);
  }

  const results = [];

  for (const id of ids) {
    let _result = [];

    for (let _key = 0, _length = rows.length, _value; _key < _length; ++_key) {
      _value = rows[_key];
      if (_value.POSTLOADER_LOOKUP_KEY === id) _result.push(_value);
    }

    const result = _result;
    results.push(result);
  }

  return results;
};

exports.default = _default;
//# sourceMappingURL=getByIdsUsingJoiningTable.js.map